; Demostracion del numero de movimientos necesarios para completar la
; torre de Hanoi - primera parte (tomado de la documentacion de ACL2)
;
; Antonio Garcia Dominguez
; $Id$
(in-package "HANOI")

(defun move (a b)
  (list 'move a 'to b))

(defun hanoi (a b c n)
  (if (zp n)
      nil
      (if (equal n 1)
	  (list (move a c))
	  (append (hanoi a c b (1- n))
		  (cons (move a c)
			(hanoi b a c (1- n)))))))

(defthm len-append
    (equal (len (append x y))
	   (+ (len x) (len y))))
